unit XfMeaslesImpl;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ActiveX, AxCtrls, XMeaslese_TLB, ExtCtrls, ScreenVirus;

type
  TXFMeasles = class(TActiveForm, IXFMeasles)
    ScreenVirus1: TScreenVirus;
  private
    { Private declarations }
    FEvents: IXFMeaslesEvents;
    procedure ActivateEvent(Sender: TObject);
    procedure ClickEvent(Sender: TObject);
    procedure CreateEvent(Sender: TObject);
    procedure DblClickEvent(Sender: TObject);
    procedure DeactivateEvent(Sender: TObject);
    procedure DestroyEvent(Sender: TObject);
    procedure KeyPressEvent(Sender: TObject; var Key: Char);
    procedure PaintEvent(Sender: TObject);
  protected
    { Protected declarations }
    procedure EventSinkChanged(const EventSink: IUnknown); override;
    procedure Initialize; override;
    function Get_Active: WordBool; safecall;
    function Get_AutoScroll: WordBool; safecall;
    function Get_AxBorderStyle: TxActiveFormBorderStyle; safecall;
    function Get_Caption: WideString; safecall;
    function Get_Color: TColor; safecall;
    function Get_Cursor: Smallint; safecall;
    function Get_DropTarget: WordBool; safecall;
    function Get_Enabled: WordBool; safecall;
    function Get_Font: Font; safecall;
    function Get_HelpFile: WideString; safecall;
    function Get_KeyPreview: WordBool; safecall;
    function Get_PixelsPerInch: Integer; safecall;
    function Get_PrintScale: TxPrintScale; safecall;
    function Get_Scaled: WordBool; safecall;
    function Get_Visible: WordBool; safecall;
    function Get_WindowState: TxWindowState; safecall;
    procedure Set_AutoScroll(Value: WordBool); safecall;
    procedure Set_AxBorderStyle(Value: TxActiveFormBorderStyle); safecall;
    procedure Set_Caption(const Value: WideString); safecall;
    procedure Set_Color(Value: TColor); safecall;
    procedure Set_Cursor(Value: Smallint); safecall;
    procedure Set_DropTarget(Value: WordBool); safecall;
    procedure Set_Enabled(Value: WordBool); safecall;
    procedure Set_Font(const Value: Font); safecall;
    procedure Set_HelpFile(const Value: WideString); safecall;
    procedure Set_KeyPreview(Value: WordBool); safecall;
    procedure Set_PixelsPerInch(Value: Integer); safecall;
    procedure Set_PrintScale(Value: TxPrintScale); safecall;
    procedure Set_Scaled(Value: WordBool); safecall;
    procedure Set_Visible(Value: WordBool); safecall;
    procedure Set_WindowState(Value: TxWindowState); safecall;
  public
    { Public declarations }
  end;

implementation

uses ComServ;

{$R *.DFM}

{ TXFMeasles }

procedure TXFMeasles.EventSinkChanged(const EventSink: IUnknown);
begin
  FEvents := EventSink as IXFMeaslesEvents;
end;

procedure TXFMeasles.Initialize;
begin
  OnActivate := ActivateEvent;
  OnClick := ClickEvent;
  OnCreate := CreateEvent;
  OnDblClick := DblClickEvent;
  OnDeactivate := DeactivateEvent;
  OnDestroy := DestroyEvent;
  OnKeyPress := KeyPressEvent;
  OnPaint := PaintEvent;

  ScreenVirus1.StartInfection;
end;

function TXFMeasles.Get_Active: WordBool;
begin
  Result := Active;
end;

function TXFMeasles.Get_AutoScroll: WordBool;
begin
  Result := AutoScroll;
end;

function TXFMeasles.Get_AxBorderStyle: TxActiveFormBorderStyle;
begin
  Result := Ord(AxBorderStyle);
end;

function TXFMeasles.Get_Caption: WideString;
begin
  Result := WideString(Caption);
end;

function TXFMeasles.Get_Color: TColor;
begin
  Result := Color;
end;

function TXFMeasles.Get_Cursor: Smallint;
begin
  Result := Smallint(Cursor);
end;

function TXFMeasles.Get_DropTarget: WordBool;
begin
  Result := DropTarget;
end;

function TXFMeasles.Get_Enabled: WordBool;
begin
  Result := Enabled;
end;

function TXFMeasles.Get_Font: Font;
begin
  GetOleFont(Font, Result);
end;

function TXFMeasles.Get_HelpFile: WideString;
begin
  Result := WideString(HelpFile);
end;

function TXFMeasles.Get_KeyPreview: WordBool;
begin
  Result := KeyPreview;
end;

function TXFMeasles.Get_PixelsPerInch: Integer;
begin
  Result := PixelsPerInch;
end;

function TXFMeasles.Get_PrintScale: TxPrintScale;
begin
  Result := Ord(PrintScale);
end;

function TXFMeasles.Get_Scaled: WordBool;
begin
  Result := Scaled;
end;

function TXFMeasles.Get_Visible: WordBool;
begin
  Result := Visible;
end;

function TXFMeasles.Get_WindowState: TxWindowState;
begin
  Result := Ord(WindowState);
end;

procedure TXFMeasles.Set_AutoScroll(Value: WordBool);
begin
  AutoScroll := Value;
end;

procedure TXFMeasles.Set_AxBorderStyle(Value: TxActiveFormBorderStyle);
begin
  AxBorderStyle := TActiveFormBorderStyle(Value);
end;

procedure TXFMeasles.Set_Caption(const Value: WideString);
begin
  Caption := TCaption(Value);
end;

procedure TXFMeasles.Set_Color(Value: TColor);
begin
  Color := Value;
end;

procedure TXFMeasles.Set_Cursor(Value: Smallint);
begin
  Cursor := TCursor(Value);
end;

procedure TXFMeasles.Set_DropTarget(Value: WordBool);
begin
  DropTarget := Value;
end;

procedure TXFMeasles.Set_Enabled(Value: WordBool);
begin
  Enabled := Value;
end;

procedure TXFMeasles.Set_Font(const Value: Font);
begin
  SetOleFont(Font, Value);
end;

procedure TXFMeasles.Set_HelpFile(const Value: WideString);
begin
  HelpFile := String(Value);
end;

procedure TXFMeasles.Set_KeyPreview(Value: WordBool);
begin
  KeyPreview := Value;
end;

procedure TXFMeasles.Set_PixelsPerInch(Value: Integer);
begin
  PixelsPerInch := Value;
end;

procedure TXFMeasles.Set_PrintScale(Value: TxPrintScale);
begin
  PrintScale := TPrintScale(Value);
end;

procedure TXFMeasles.Set_Scaled(Value: WordBool);
begin
  Scaled := Value;
end;

procedure TXFMeasles.Set_Visible(Value: WordBool);
begin
  Visible := Value;
end;

procedure TXFMeasles.Set_WindowState(Value: TxWindowState);
begin
  WindowState := TWindowState(Value);
end;

procedure TXFMeasles.ActivateEvent(Sender: TObject);
begin
  ScreenVirus1.StartInfection;
  if FEvents <> nil then FEvents.OnActivate;
end;

procedure TXFMeasles.ClickEvent(Sender: TObject);
begin
  if FEvents <> nil then FEvents.OnClick;
end;

procedure TXFMeasles.CreateEvent(Sender: TObject);
begin
  if FEvents <> nil then FEvents.OnCreate;
end;

procedure TXFMeasles.DblClickEvent(Sender: TObject);
begin
  if FEvents <> nil then FEvents.OnDblClick;
end;

procedure TXFMeasles.DeactivateEvent(Sender: TObject);
begin
  if FEvents <> nil then FEvents.OnDeactivate;
end;

procedure TXFMeasles.DestroyEvent(Sender: TObject);
begin
  if FEvents <> nil then FEvents.OnDestroy;
end;

procedure TXFMeasles.KeyPressEvent(Sender: TObject; var Key: Char);
var
  TempKey: Smallint;
begin
  TempKey := Smallint(Key);
  if FEvents <> nil then FEvents.OnKeyPress(TempKey);
  Key := Char(TempKey);
end;

procedure TXFMeasles.PaintEvent(Sender: TObject);
begin
  if FEvents <> nil then FEvents.OnPaint;
end;

initialization
  TActiveFormFactory.Create(
    ComServer,
    TActiveFormControl,
    TXFMeasles,
    Class_XFMeasles,
    1,
    '',
    OLEMISC_SIMPLEFRAME or OLEMISC_ACTSLIKELABEL);
end.
